/*
 * n01_tools
 *
 * n01_tools.c
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "..\n01_plugin.h"
#include "resource.h"

/* Define */
#define UNDO_MAX						1024

#define WM_WINDOW_SET_FIRST				(WM_APP + 3)
#define WM_SCORE_GET_BUFFER				(WM_APP + 114)
#define WM_PLAYER_DRAW_INIT				(WM_APP + 301)

#ifndef EM_REDO
#define EM_REDO							(WM_USER + 84)
#endif
#ifndef EM_CANREDO
#define EM_CANREDO						(WM_USER + 85)
#endif

/* Global Variables */
static  HINSTANCE hInst;

typedef struct _DRAW_BUFFER {
	HWND hedit;				// EDIT̃nh
} DRAW_BUFFER;

typedef struct _UNDO_INFO {
	int score;
	int x;
	int y;
	BOOL null_flag;

	int first;
	int current_round;
	int current_player;
} UNDO_INFO;

static UNDO_INFO tmp_ui;
static UNDO_INFO ui[UNDO_MAX];
static int ui_index;
static int ui_count;
static BOOL undo_flag;

/* Local Function Prototypes */

/*
 * DllMain - C
 */
int WINAPI DllMain(HINSTANCE hInstance, DWORD fdwReason, PVOID pvReserved)
{
	switch (fdwReason) {
	case DLL_PROCESS_ATTACH:
		hInst = hInstance;
		break;

	case DLL_PROCESS_DETACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		break;
	}
	return TRUE;
}

/*
 * get_plugin_info - vOC擾
 */
__declspec(dllexport) BOOL CALLBACK get_plugin_info(const HWND hWnd, const int index, PLUGIN_GET_INFO *pgi)
{
	switch (index) {
	case 0:
		LoadString(hInst, IDS_STRING_UNDO, pgi->title, BUF_SIZE - 1);
		lstrcpy(pgi->func_name, TEXT("n01_undo"));
		lstrcpy(pgi->cmd_line, TEXT(""));
		return TRUE;

	case 1:
		LoadString(hInst, IDS_STRING_REDO, pgi->title, BUF_SIZE - 1);
		lstrcpy(pgi->func_name, TEXT("n01_redo"));
		lstrcpy(pgi->cmd_line, TEXT(""));
		return TRUE;

	case 2:
		LoadString(hInst, IDS_STRING_NAME, pgi->title, BUF_SIZE - 1);
		lstrcpy(pgi->func_name, TEXT("n01_name"));
		lstrcpy(pgi->cmd_line, TEXT(""));
		return TRUE;
	}
	return FALSE;
}

/*
 * n01_undo_initialize - vOC̏
 */
__declspec(dllexport) BOOL CALLBACK n01_undo_initialize(const HWND hWnd, PLUGIN_EXEC_INFO *pei)
{
	return (CALLTYPE_MENU | CALLTYPE_LEG_START | CALLTYPE_INPUT_START | CALLTYPE_INPUT_END | CALLTYPE_PREV_LEG);
}

/*
 * get_hedit - EDITEBhE̎擾
 */
static HWND get_hedit(const HWND hWnd)
{
	DRAW_BUFFER *bf;
	WINDOW_INFO *wi;

	bf = (DRAW_BUFFER *)SendMessage(hWnd, WM_N01_GET_SCORE_BUFFER, 0, 0);
	if (bf != NULL) {
		return bf->hedit;
	}
	wi = (WINDOW_INFO *)SendMessage(hWnd, WM_N01_GET_WINDOW, 0, 0);
	bf = (DRAW_BUFFER *)SendMessage(wi->score_list_wnd, WM_SCORE_GET_BUFFER, 0, 0);
	if (bf != NULL) {
		return bf->hedit;
	}
	return NULL;
}

/*
 * n01_undo
 */
__declspec(dllexport) int CALLBACK n01_undo(const HWND hWnd, const int call_type, PLUGIN_EXEC_INFO *pei, int param)
{
	TCHAR buf[BUF_SIZE];
	int i;
	BOOL check_out_mode;

	switch (call_type) {
	case CALLTYPE_MENU:
		if (SendMessage(get_hedit(hWnd), EM_CANUNDO, 0, 0) == TRUE) {
			SendMessage(get_hedit(hWnd), EM_UNDO, 0, 0);
			break;
		}
		if (ui_index <= 0) {
			break;
		}
		if (pei->si->player[0].lock == TRUE || pei->si->player[1].lock == TRUE) {
			break;
		}
		undo_flag = TRUE;
		ui_index--;
		// ͈ʒu̐ݒ
		SendMessage(hWnd, WM_N01_SET_INPUT_POS, FALSE, (LPARAM)MAKELPARAM(ui[ui_index].x, ui[ui_index].y));
		// UNDOȌۑ
		i = ui[ui_index].score;
		SendMessage(get_hedit(hWnd), WM_GETTEXT, BUF_SIZE - 1, (LPARAM)buf);
		ui[ui_index].score = atoi(buf);
		// Leg̕
		pei->si->leg[pei->si->current_leg].first = ui[ui_index].first;
		pei->si->leg[pei->si->current_leg].current_round = ui[ui_index].current_round;
		pei->si->leg[pei->si->current_leg].current_player = ui[ui_index].current_player;
		// XRA̕
		SendMessage(hWnd, WM_N01_SCORE_INPUT, i, 1);
		check_out_mode = pei->si->player[ui[ui_index].x].check_out_mode;
		pei->si->player[ui[ui_index].x].check_out_mode = FALSE;
		SendMessage(hWnd, WM_N01_SET_INPUT_POS, TRUE, (LPARAM)MAKELPARAM(-1, -1));
		pei->si->player[ui[ui_index].x].check_out_mode = check_out_mode;
		if (ui[ui_index].null_flag == TRUE) {
			pei->si->leg[pei->si->current_leg].first = ui[ui_index].first;
			pei->si->leg[pei->si->current_leg].current_round = ui[ui_index].current_round;
			pei->si->leg[pei->si->current_leg].current_player = ui[ui_index].current_player;
			SendMessage(hWnd, WM_N01_REFRESH, 0, 0);
		}
		SendMessage(hWnd, WM_WINDOW_SET_FIRST, TRUE, 0);
		undo_flag = FALSE;
		break;

	case CALLTYPE_LEG_START:
		ui_count = ui_index = 0;
		break;

	case CALLTYPE_INPUT_START:
		// ͑ÕXRAۑ
		SendMessage(get_hedit(hWnd), WM_GETTEXT, BUF_SIZE - 1, (LPARAM)buf);
		tmp_ui.score = atoi(buf);
		tmp_ui.null_flag = (*buf == TEXT('\0')) ? TRUE : FALSE;
		SendMessage(hWnd, WM_N01_GET_INPUT_POS, (WPARAM)&tmp_ui.x, (LPARAM)&tmp_ui.y);
		// Leg̕ۑ
		tmp_ui.first = pei->si->leg[pei->si->current_leg].first;
		tmp_ui.current_round = pei->si->leg[pei->si->current_leg].current_round;
		tmp_ui.current_player = pei->si->leg[pei->si->current_leg].current_player;
		break;

	case CALLTYPE_INPUT_END:
		if (undo_flag == TRUE) {
			break;
		}
		if (ui_index >= UNDO_MAX) {
			MoveMemory(ui, ui + 1, sizeof(UNDO_INFO) * (ui_index - 1));
			ui_index--;
		}
		// UNDOɒǉ
		ui[ui_index] = tmp_ui;
		ui_index++;
		ui_count = ui_index;
		break;

	case CALLTYPE_PREV_LEG:
		ui_count = ui_index = 0;
		break;
	}
	return PLUGIN_SUCCEED;
}

/*
 * n01_redo_initialize - vOC̏
 */
__declspec(dllexport) BOOL CALLBACK n01_redo_initialize(const HWND hWnd, PLUGIN_EXEC_INFO *pei)
{
	return (CALLTYPE_MENU);
}

/*
 * n01_redo
 */
__declspec(dllexport) int CALLBACK n01_redo(const HWND hWnd, const int call_type, PLUGIN_EXEC_INFO *pei, int param)
{
	TCHAR buf[BUF_SIZE];
	int i;
	BOOL check_out_mode;

	switch (call_type) {
	case CALLTYPE_MENU:
		if (SendMessage(get_hedit(hWnd), EM_CANREDO, 0, 0) == TRUE) {
			SendMessage(get_hedit(hWnd), EM_REDO, 0, 0);
			break;
		}
		if (ui_count <= 0 || ui_index >= ui_count) {
			break;
		}
		undo_flag = TRUE;
		// ͈ʒu̐ݒ
		SendMessage(hWnd, WM_N01_SET_INPUT_POS, FALSE, (LPARAM)MAKELPARAM(ui[ui_index].x, ui[ui_index].y));
		// REDOȌۑ
		i = ui[ui_index].score;
		SendMessage(get_hedit(hWnd), WM_GETTEXT, BUF_SIZE - 1, (LPARAM)buf);
		ui[ui_index].score = atoi(buf);
		ui[ui_index].null_flag = (*buf == TEXT('\0')) ? TRUE : FALSE;
		// XRA̕
		check_out_mode = pei->si->player[ui[ui_index].x].check_out_mode;
		pei->si->player[ui[ui_index].x].check_out_mode = FALSE;
		SendMessage(hWnd, WM_N01_SCORE_INPUT, i, 0);
		SendMessage(hWnd, WM_N01_SET_INPUT_POS, TRUE, (LPARAM)MAKELPARAM(-1, -1));
		pei->si->player[ui[ui_index].x].check_out_mode = check_out_mode;
		SendMessage(hWnd, WM_WINDOW_SET_FIRST, TRUE, 0);
		ui_index++;
		undo_flag = FALSE;
		break;
	}
	return PLUGIN_SUCCEED;
}

/*
 * n01_name_initialize - vOC̏
 */
__declspec(dllexport) BOOL CALLBACK n01_name_initialize(const HWND hWnd, PLUGIN_EXEC_INFO *pei)
{
	return (CALLTYPE_MENU);
}

/*
 * set_name_proc - EBhEvV[W
 */
static BOOL CALLBACK set_name_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	SCORE_INFO *si;

	switch (msg) {
	case WM_INITDIALOG:
		si = (SCORE_INFO *)lParam;
		if (si == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		SetWindowLong(hDlg, GWL_USERDATA, lParam);

		SendDlgItemMessage(hDlg, IDC_EDIT_NAME_1, WM_SETTEXT, 0, (LPARAM)si->player[0].name);
		SendDlgItemMessage(hDlg, IDC_EDIT_NAME_2, WM_SETTEXT, 0, (LPARAM)si->player[1].name);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			si = (SCORE_INFO *)GetWindowLong(hDlg, GWL_USERDATA);

			SendDlgItemMessage(hDlg, IDC_EDIT_NAME_1, WM_GETTEXT, NAME_SIZE - 1, (LPARAM)si->player[0].name);
			SendDlgItemMessage(hDlg, IDC_EDIT_NAME_2, WM_GETTEXT, NAME_SIZE - 1, (LPARAM)si->player[1].name);

			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * n01_name
 */
__declspec(dllexport) int CALLBACK n01_name(const HWND hWnd, const int call_type, PLUGIN_EXEC_INFO *pei, int param)
{
	WINDOW_INFO *wi;
	GAME_INFO *gi;

	switch (call_type) {
	case CALLTYPE_MENU:
		if (DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_NAME), hWnd, set_name_proc, (LPARAM)pei->si) == FALSE) {
			break;
		}
		gi = (GAME_INFO *)SendMessage(hWnd, WM_N01_GET_GAME_OPTION, 0, 0);
		lstrcpy(gi->player_name[0], pei->si->player[0].name);
		lstrcpy(gi->player_name[1], pei->si->player[1].name);

		wi = (WINDOW_INFO *)SendMessage(hWnd, WM_N01_GET_WINDOW, 0, 0);
		SendMessage(wi->score_player_wnd[0], WM_PLAYER_DRAW_INIT, 0, 0);
		SendMessage(wi->score_player_wnd[1], WM_PLAYER_DRAW_INIT, 0, 0);
		break;
	}
	return PLUGIN_SUCCEED;
}
/* End of source */
